"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .source import Source, SourceTypedDict
from cloudinary_analysis.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class AnalyzeAIVisionGeneralRequestTypedDict(TypedDict):
    source: SourceTypedDict
    async_: NotRequired[bool]
    r"""Whether to perform the analysis asynchronously.
    If true, the response is returned immediately and analysis is done in the background.
    Once complete, a webhook notification will be sent to the specified URL and/or to the URLs defined in the Webhook Notifications settings of your Cloudinary Console.
    """
    notification_url: NotRequired[str]
    r"""The webhook URL to notify when the analysis is complete. Only relevant when async is set to true."""
    prompts: NotRequired[List[str]]
    r"""One or more prompts of open questions or tasks with an open answer"""


class AnalyzeAIVisionGeneralRequest(BaseModel):
    source: Source

    async_: Annotated[Optional[bool], pydantic.Field(alias="async")] = None
    r"""Whether to perform the analysis asynchronously.
    If true, the response is returned immediately and analysis is done in the background.
    Once complete, a webhook notification will be sent to the specified URL and/or to the URLs defined in the Webhook Notifications settings of your Cloudinary Console.
    """

    notification_url: Optional[str] = None
    r"""The webhook URL to notify when the analysis is complete. Only relevant when async is set to true."""

    prompts: Optional[List[str]] = None
    r"""One or more prompts of open questions or tasks with an open answer"""
