"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .source import Source, SourceTypedDict
from cloudinary_analysis.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class TagDefinitionsTypedDict(TypedDict):
    name: str
    r"""The name of the tag to apply. This can be any string and does not affect the decision process"""
    description: str
    r"""A description to be used by the AI to determine whether the tag should be applied"""


class TagDefinitions(BaseModel):
    name: str
    r"""The name of the tag to apply. This can be any string and does not affect the decision process"""

    description: str
    r"""A description to be used by the AI to determine whether the tag should be applied"""


class AnalyzeAIVisionTaggingRequestTypedDict(TypedDict):
    source: SourceTypedDict
    tag_definitions: List[TagDefinitionsTypedDict]
    async_: NotRequired[bool]
    r"""Whether to perform the analysis asynchronously.
    If true, the response is returned immediately and analysis is done in the background.
    Once complete, a webhook notification will be sent to the specified URL and/or to the URLs defined in the Webhook Notifications settings of your Cloudinary Console.
    """
    notification_url: NotRequired[str]
    r"""The webhook URL to notify when the analysis is complete. Only relevant when async is set to true."""


class AnalyzeAIVisionTaggingRequest(BaseModel):
    source: Source

    tag_definitions: List[TagDefinitions]

    async_: Annotated[Optional[bool], pydantic.Field(alias="async")] = None
    r"""Whether to perform the analysis asynchronously.
    If true, the response is returned immediately and analysis is done in the background.
    Once complete, a webhook notification will be sent to the specified URL and/or to the URLs defined in the Webhook Notifications settings of your Cloudinary Console.
    """

    notification_url: Optional[str] = None
    r"""The webhook URL to notify when the analysis is complete. Only relevant when async is set to true."""
