"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .feature import Feature
from cloudinary_analysis.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from datetime import datetime
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class LimitTypedDict(TypedDict):
    type: Feature
    used_by_request: NotRequired[Nullable[int]]
    r"""The amount of quota used by the current request"""
    remaining: NotRequired[Nullable[int]]
    r"""The remaining quota"""
    limit: NotRequired[Nullable[int]]
    r"""The total quota limit"""
    reset_time: NotRequired[Nullable[datetime]]
    r"""Time in UTC when the limit will be reset"""


class Limit(BaseModel):
    type: Feature

    used_by_request: OptionalNullable[int] = UNSET
    r"""The amount of quota used by the current request"""

    remaining: OptionalNullable[int] = UNSET
    r"""The remaining quota"""

    limit: OptionalNullable[int] = UNSET
    r"""The total quota limit"""

    reset_time: OptionalNullable[datetime] = UNSET
    r"""Time in UTC when the limit will be reset"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["used_by_request", "remaining", "limit", "reset_time"]
        nullable_fields = ["used_by_request", "remaining", "limit", "reset_time"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class LimitsObjectTypedDict(TypedDict):
    items: NotRequired[List[LimitTypedDict]]


class LimitsObject(BaseModel):
    items: Optional[List[Limit]] = None
